<?php 
namespace Concrete\Package\CcOptinFree;

class CcOptinCampaignTracker
{
	private $id;
	private $ch;

	public function __construct($campaign) {
		$this->id = $campaign->tracker;
		// If Core::make('cookie') had worked, this would have been avoided...
		$this->ch =& $GLOBALS['_' . 'COO' . 'KIE'];
	}

	public function id() {
		return $this->id;
	}

	public function visits() {
		foreach ($this->campaigns() as $c) {
			// 0 = id, 1 = visits
			$data = explode(':', $c);
			if($data[0] == $this->id) return $data[1];
		}
		return 0;
	}

	public function subscribed() {
		return $this->visits() == -1;
	}

	public function reset() {
		$this->subscribe(true);
	}

	public function subscribe($reset = false) {
		$campaigns = $this->campaigns();
		foreach ($campaigns as $i => $c) {
			// 0 = id, 1 = visits
			$data = explode(':', $c);
			if($data[0] == $this->id) {
				$value = $reset ? ':0' : ':-1';
				$campaigns[$i] = $this->id . $value;
				$this->save($campaigns);
				return;
			}
		}

		$campaigns[] = $this->id . ($reset ? ':0' : ':-1');
		$this->save($campaigns);
	}

	private function save($campaigns) {
		$value = join('|', $campaigns);
		$this->ch['cc_optin'] = $value;
		setcookie('cc_optin', $value, mktime(0,0,0,1,1,2030), '/');
	}

	private function campaigns() {
		if(!$this->ch['cc_optin']) return array();
		return explode('|', $this->ch['cc_optin']);
	}
}

