// Generated by CoffeeScript 1.7.1
(function() {
  var CampaignButtonController, EditController, GalleryController, ToggleController, t,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  t = window.ccOptin.t;

  EditController = (function() {
    function EditController() {
      this.topbar_setupPills = __bind(this.topbar_setupPills, this);
      this.types_setNew = __bind(this.types_setNew, this);
      this.templates_setPreview = __bind(this.templates_setPreview, this);
      this.dialog_openContentDialog = __bind(this.dialog_openContentDialog, this);
      this.loaded = __bind(this.loaded, this);
      this.form = $('#campaign-controller-form');
      this.idInput = this.form.find('input[name=id]');
      this.dialog = this.form.closest('.ui-dialog');
      this.notifications = ConcreteAlert;
      this.textEditors = ['sa_displayMessage', 'sa_sendEmail_body'];
      this.dashboard = window.ConcreteDashboard;
      this.editContentButton = $('#edit-content-button');
      this.saveButton = $('#save-campaign-button');
      this.hiddenEditDesignLink = $('#cc-optin-edit-design-link');
      this.types = this.form.find('.type-gallery .gallery-item:first > img');
      this.typeClass = this.form.find("input[name=typeClass]");
      this.templateContainer = this.form.find('.design-gallery');
      this.templateHandle = this.form.find("input[name=templateHandle]");
      this.templateLoader = this.form.find('.ccm-scroller-loader').hide();
      this.topBar = $('.topbar');
      this.toolTips = $('i.fa-question-circle');
      this.activeCampaigns = ccOptin.DisplayCampaign;
      this.ajaxForm = new ccOptin.AjaxForm({
        form: this.form,
        updateIdProperty: 'id',
        onBefore: (function(_this) {
          return function() {
            return $.fn.dialog.showLoader();
          };
        })(this),
        onSuccess: (function(_this) {
          return function(data) {
            _this.notifications.notify({
              message: t('Campaign was saved successfully.')
            });
            return $.fn.dialog.hideLoader();
          };
        })(this),
        onValidationError: (function(_this) {
          return function(errors) {
            if (errors.creatingNew) {
              return;
            }
            _this.notifications.notify({
              type: 'danger',
              icon: 'warning',
              message: t('Could not save campaign. Check the errors and try again.')
            });
            setTimeout((function() {
              var _ref;
              return (_ref = _this.topBar.data('ccscrollspy')) != null ? _ref.refresh() : void 0;
            }), 100);
            return $.fn.dialog.hideLoader();
          };
        })(this)
      });
    }

    EditController.prototype.loaded = function() {
      var id, updateScrollSpy, _i, _len, _ref;
      this.saveButton.on('click', (function(_this) {
        return function(e) {
          var isNew;
          e.preventDefault();
          isNew = !_this.idInput.val();
          return _this.ajaxForm.submit().done(function() {
            _this.saveButton.text(t('Save'));
            _this.editContentButton.show();
            if (isNew) {
              return _this.dialog_openContentDialog();
            }
            if (_this.dashboard) {
              $.fn.dialog.showLoader();
              return location.reload();
            } else {
              return $.fn.dialog.closeTop();
            }
          });
        };
      })(this));
      this.editContentButton.on('click', (function(_this) {
        return function(e) {
          e.preventDefault();
          $.fn.dialog.showLoader();
          if (!_this.idInput.val()) {
            return _this.ajaxForm.submit().done(_this.dialog_openContentDialog);
          } else if (_this.ajaxForm.changed()) {
            return _this.types_setNew().done(_this.dialog_openContentDialog);
          } else {
            return _this.dialog_openContentDialog();
          }
        };
      })(this));
      this.toolTips.tooltip();
      if (this.activeCampaigns) {
        this.activeCampaigns.editMode = true;
      }
      this.dialog.on('dialogbeforeclose', (function(_this) {
        return function() {
          if (_this.activeCampaigns) {
            _this.activeCampaigns.editMode = false;
          }
          return true;
        };
      })(this));
      updateScrollSpy = (function(_this) {
        return function() {
          return ccOptin.debounce((function() {
            var _ref;
            return (_ref = _this.topBar.data('ccscrollspy')) != null ? _ref.refresh() : void 0;
          }), 20);
        };
      })(this);
      _ref = this.textEditors;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        id = _ref[_i];
        $('#' + id).redactor({
          initCallback: updateScrollSpy,
          changeCallback: updateScrollSpy
        });
      }
      this.types.on('click', (function(_this) {
        return function(e) {
          _this.templateContainer.empty();
          _this.templateLoader.show();
          return $.ajax({
            url: _this.form.attr('action'),
            data: {
              ccaction: 'templates',
              handle: _this.templateHandle.val(),
              typeClass: $(e.target).closest('.gallery-item').data('gallery-item')
            },
            success: function(html) {
              _this.templateLoader.hide();
              _this.templateContainer.html(html);
              _this.templates_setPreview();
              _this.templateContainer.find('.gallery-item > img').css('cursor', 'pointer');
              if (!_this.templateContainer.find('.gallery-item.selected').length) {
                _this.templateHandle.val('');
              }
              return setTimeout(updateScrollSpy, 250);
            }
          });
        };
      })(this));
      this.templates_setPreview();
      this.topbar_setupPills();
      $('#cc-optin-edit-campaign').removeClass('ccm-launch-panel-loading');
      setTimeout(updateScrollSpy, 1000);
      return this;
    };

    EditController.prototype.dialog_openContentDialog = function() {
      var link;
      link = this.hiddenEditDesignLink;
      return $.fn.dialog.open({
        title: t('Edit content and settings'),
        href: link.attr('href') + this.idInput.val(),
        width: link.data('width'),
        height: link.data('height'),
        modal: true
      });
    };

    EditController.prototype.templates_setPreview = function(e) {
      var designs;
      designs = this.templateContainer.find('.gallery-item').length;
      if (designs > 0) {
        return this.templateContainer.find('a.preview').imgPreview({
          preloadImages: false,
          onShow: function(link) {
            return $('<span>' + $(link).attr('title') + '</span>').appendTo(this);
          },
          onHide: function(link) {
            return $('span', this).remove();
          },
          distanceFromCursor: {
            top: -200,
            left: 10
          }
        }).off('click').on('click', function() {
          return false;
        });
      }
    };

    EditController.prototype.types_setNew = function() {
      var data;
      data = this.form.serialize() + '&ccaction=setdesign';
      return $.post(this.form.attr('action'), data).done((function(_this) {
        return function(response) {
          if (response.error) {
            return _this.notifications.notify({
              type: 'danger',
              icon: 'warning',
              message: response.error.summary
            });
          } else {
            return _this.notifications.notify({
              message: response.success
            });
          }
        };
      })(this));
    };

    EditController.prototype.topbar_setupPills = function() {
      this.topBar.insertAfter('.ui-dialog-titlebar');
      return setTimeout((function(_this) {
        return function() {
          return _this.topBar.ccScrollSpy({
            window: _this.topBar.next()
          });
        };
      })(this), 100);
    };

    return EditController;

  })();

  GalleryController = (function() {
    function GalleryController(editController) {
      this.loaded = __bind(this.loaded, this);
      this.editController = editController;
      this.typeGallery = $('.type-gallery');
      this.designGallery = $('.design-gallery');
      this.idInput = editController.idInput;
    }

    GalleryController.prototype.loaded = function() {
      var gallery, _i, _len, _ref;
      _ref = [this.typeGallery, this.designGallery];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        gallery = _ref[_i];
        gallery.find('.gallery-item > img').css('cursor', 'pointer');
        gallery.on('click', '.gallery-item > img', (function(_this) {
          return function(e) {
            var g, item;
            g = $(e.delegateTarget);
            g.find('.gallery-item').removeClass('selected');
            item = $(e.target).closest('.gallery-item').addClass('selected');
            return $('input[name="' + g.data('field') + '"]').val(item.data('gallery-item'));
          };
        })(this));
      }
      this.typeGallery.find('.gallery-item:last > img').css('cursor', 'auto').on('click', function(e) {
        e.stopPropagation();
        return false;
      });
    };

    return GalleryController;

  })();

  CampaignButtonController = (function() {
    function CampaignButtonController(ajaxForm) {
      this.form_openNewDialog = __bind(this.form_openNewDialog, this);
      this.notifications_displayMessage = __bind(this.notifications_displayMessage, this);
      this.createNewCampaign = __bind(this.createNewCampaign, this);
      this.resetCampaign = __bind(this.resetCampaign, this);
      this.switchCampaign = __bind(this.switchCampaign, this);
      this.duplicateCampaign = __bind(this.duplicateCampaign, this);
      this.loaded = __bind(this.loaded, this);
      this.ajaxForm = ajaxForm;
      this.form = this.ajaxForm.form;
      this.idInput = this.form.find('input[name=id]');
      this.notifications = ConcreteAlert;
      this.newButton = $('#new-campaign-button');
      this.resetButton = $('#reset-campaign-button');
      this.duplicateButton = $('#duplicate-campaign-button');
      this.otherCampaigns = $('#other-campaigns');
    }

    CampaignButtonController.prototype.loaded = function() {
      this.newButton.on('click', this.createNewCampaign);
      this.resetButton.on('click', this.resetCampaign);
      this.duplicateButton.on('click', this.duplicateCampaign);
      this.otherCampaigns.on('focus', (function(_this) {
        return function() {
          return _this.otherCampaigns.data('previous', _this.otherCampaigns.val());
        };
      })(this));
      this.otherCampaigns.on('change', this.switchCampaign);
      return this;
    };

    CampaignButtonController.prototype.duplicateCampaign = function(e) {
    };

    CampaignButtonController.prototype.switchCampaign = function(e) {
    };

    CampaignButtonController.prototype.resetCampaign = function(e) {
      if (e) {
        e.preventDefault();
      }
      if (!window.confirm(t('Confirm reset of campaign cookie.'))) {
        return;
      }
      $.fn.dialog.showLoader();
      return $.ajax({
        type: 'POST',
        url: this.form.attr('action'),
        data: {
          ccaction: 'reset',
          id: this.idInput.val()
        },
        success: (function(_this) {
          return function(message) {
            $.fn.dialog.hideLoader();
            return _this.notifications_displayMessage(message);
          };
        })(this)
      });
    };

    CampaignButtonController.prototype.createNewCampaign = function(e) {
    };

    CampaignButtonController.prototype.notifications_displayMessage = function(msg) {
      var icon, status, text;
      status = msg.error ? 'danger' : 'success';
      icon = msg.error ? 'warning' : 'check';
      text = msg.error ? msg.error.summary : msg.success;
      return this.notifications.notify({
        type: status,
        icon: icon,
        message: text
      });
    };

    CampaignButtonController.prototype.form_openNewDialog = function(query) {
      var url;
      url = this.form.attr('action');
      return $.fn.dialog.open({
        title: t('Edit Campaign'),
        href: url + (query ? '?' + query : ''),
        width: this.form.data('width'),
        height: this.form.data('height'),
        modal: true
      });
    };

    return CampaignButtonController;

  })();

  ToggleController = (function() {
    function ToggleController(editController) {
      this.loaded = __bind(this.loaded, this);
      this.edit = editController;
      this.togglers = $('input[type=checkbox].contentToggle');
    }

    ToggleController.prototype.loaded = function() {
      var refreshScrollSpy, toggleDiv;
      toggleDiv = function(el) {
        return $(el).parent().nextAll('div.toggleThis:first');
      };
      refreshScrollSpy = (function(_this) {
        return function() {
          var _ref;
          return (_ref = _this.edit.topBar.data('ccscrollspy')) != null ? _ref.refresh() : void 0;
        };
      })(this);
      setTimeout((function(_this) {
        return function() {
          return _this.togglers.on('click', function() {
            return toggleDiv(this).slideToggle('slow', refreshScrollSpy);
          }).each(function() {
            if ($(this).is(':checked')) {
              return toggleDiv(this).show();
            }
          });
        };
      })(this), 100);
      return this;
    };

    return ToggleController;

  })();

  $(function() {
    var edit;
    t = window.ccOptin.t;
    edit = new EditController().loaded();
    new CampaignButtonController(edit.ajaxForm).loaded();
    new ToggleController(edit).loaded();
    return new GalleryController(edit).loaded();
  });

}).call(this);

//# sourceMappingURL=edit.map
