// Generated by CoffeeScript 1.7.1

/*
Ajax form submitter with validation.
Check the note on http://api.jquery.com/serialize/ before using.

Should be returned from form submission url:

error:
	validation:
		fieldName: optionalErrorMsg
		anotherField: optionalErrorMsg
		...
	summary: textForSummaryField
 */

(function() {
  var AjaxForm,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  window.ccOptin.AjaxForm = AjaxForm = (function() {
    AjaxForm.errorClass = 'val-error';

    AjaxForm.fieldText = 'val-field-text';

    AjaxForm.valFieldName = 'data-val-field';

    AjaxForm.valSummaryName = 'data-val-summary';

    AjaxForm.valLoaderName = 'data-val-loader';

    AjaxForm.onChangeInterval = 200;

    function AjaxForm(options) {
      this.showErrors = __bind(this.showErrors, this);
      this.hideErrors = __bind(this.hideErrors, this);
      this.updateId = __bind(this.updateId, this);
      this.submit = __bind(this.submit, this);
      this.changed = __bind(this.changed, this);
      this.setForm = __bind(this.setForm, this);
      this.noSubmit = options.noSubmit;
      this.updateIdProperty = options.updateIdProperty;
      this.onBefore = options.onBefore;
      this.onValidationError = options.onValidationError;
      this.onSuccess = options.onSuccess;
      this.onError = options.onError;
      this.onChange = options.onChange;
      this.onChangeInterval = options.onChangeInterval || AjaxForm.onChangeInterval;
      if (options.loader) {
        this.loaders = $(options.loader);
      }
      if (options.form) {
        this.setForm(options.form);
      }
      if (options.errors) {
        this.showErrors(options.errors);
      }
    }

    AjaxForm.prototype.setForm = function(form) {
      var hiddenData;
      if (this.form) {
        throw "Multiple AjaxForm.setForm assignments not allowed";
      }
      this.form = $(form);
      this.form.find("*[" + AjaxForm.valFieldName + "]").map(function() {
        return $(this).data(AjaxForm.fieldText, $(this).text());
      });
      if (!this.noSubmit) {
        this.form.on('submit', this.submit);
      }
      this._formState = this.form.serialize();
      if (this.onChange) {
        this.form.on('change', ':input', (function(_this) {
          return function(e) {
            return _this.onChange(e);
          };
        })(this));
        hiddenData = null;
        setInterval((function(_this) {
          return function() {
            if (_this.onChange && hiddenData && _this.form.find('input:hidden').serialize() !== hiddenData) {
              _this.onChange(null);
            }
            return hiddenData = _this.form.find('input:hidden').serialize();
          };
        })(this), this.onChangeInterval);
      }
      if (!this.loaders) {
        this.loaders = this.form.find("*[" + AjaxForm.valLoaderName + "]").hide();
      }
      return this;
    };

    AjaxForm.prototype.changed = function() {
      return this._formState !== this.form.serialize();
    };

    AjaxForm.prototype.submit = function(e) {
      var def;
      if (e == null) {
        e = null;
      }
      if (e) {
        e.preventDefault();
      }
      def = $.Deferred();
      if (this.onBefore && this.onBefore(this.form) === false) {
        return def.reject({}).promise();
      }
      this.hideErrors();
      this.loaders.show();
      $.ajax({
        type: this.form.attr('method') || 'POST',
        url: this.form.attr('action'),
        data: this.form.serialize(),
        success: (function(_this) {
          return function(data) {
            if (typeof data === 'string') {
              _this.loaders.hide();
              if (typeof console !== "undefined" && console !== null ? console.log : void 0) {
                console.log(data);
              }
              alert('An unknown error occured. Please reload page and try again.');
              return;
            }
            if (data && (data.error != null)) {
              _this.showErrors(data.error);
              def.reject(data.error);
            } else {
              if (_this.updateIdProperty) {
                _this.updateId(data[_this.updateIdProperty], _this.updateIdProperty);
              }
              if (_this.onSuccess) {
                _this.onSuccess(data);
              }
              _this._formState = _this.form.serialize();
              def.resolve(data);
            }
            return _this.loaders.hide();
          };
        })(this),
        error: (function(_this) {
          return function(jqXHR, textStatus, errorThrown) {
            if (_this.onError) {
              _this.onError(textStatus, errorThrown);
            }
            def.reject(textStatus);
            return _this.loaders.hide();
          };
        })(this)
      });
      return def.promise();
    };

    AjaxForm.prototype.updateId = function(value, field) {
      if (field == null) {
        field = 'id';
      }
      this.form.find('*[name="' + field + '"]').val(value);
      return this;
    };

    AjaxForm.prototype.hideErrors = function() {
      this.form.find("." + this.errorClass).removeClass(this.errorClass);
      this.form.find("*[" + AjaxForm.valSummaryName + "]").hide();
      this.form.find("*[" + AjaxForm.valFieldName + "]").hide();
      return this;
    };

    AjaxForm.prototype.showErrors = function(errors) {
      var errorFieldFocused, field, msg, name, summary, ul, valField, _ref;
      if (!this.form) {
        return this;
      }
      if (this.onValidationError && this.onValidationError(errors) === false) {
        return this;
      }
      errorFieldFocused = false;
      if (errors.validation != null) {
        _ref = errors.validation;
        for (name in _ref) {
          msg = _ref[name];
          name = name.replace(/'/g, "\\'");
          valField = this.form.find("*[" + AjaxForm.valFieldName + "='" + name + "']");
          valField.text(msg ? msg : valField.data(AjaxForm.fieldText)).show();
          field = this.form.find("*[name='" + name + "']").addClass(this.errorClass);
          if (errorFieldFocused) {
            continue;
          }
          if (field.length && !field.is(':hidden')) {
            field.focus();
            errorFieldFocused = true;
          } else if (valField.length) {
            this._elementFocus(valField.first());
            errorFieldFocused = true;
          }
        }
      }
      if (errors.summary != null) {
        summary = this.form.find("*[" + AjaxForm.valSummaryName + "]").empty();
        if (typeof errors.summary === 'string') {
          summary.text(errors.summary);
        } else {
          ul = $('<ul></ul>');
          $.each(errors.summary, function(_, val) {
            return ul.append($('<li></li>').text(val));
          });
          ul.appendTo(summary);
        }
        summary.show();
        if (!errorFieldFocused) {
          this._elementFocus(summary.first());
        }
      }
      return this;
    };

    AjaxForm.prototype._elementFocus = function(el) {
      if (el.attr('tabindex') != null) {
        return el.focus();
      }
      return el.attr('tabindex', -1).focus().removeAttr('tabindex');
    };

    return AjaxForm;

  })();

}).call(this);

//# sourceMappingURL=ajaxform.map
