// Generated by CoffeeScript 1.7.1
(function() {
  (function(factory) {
    if (typeof define === "function" && define.amd) {
      define(["jquery"], factory);
    } else {
      factory(jQuery);
    }
  })(function($) {
    var $t, distance, functions, inWords, prepareData, refresh, t;
    t = window.ccOptin.t;
    refresh = function() {
      var $s, data;
      data = prepareData(this);
      $s = $t.settings;
      if (!isNaN(data.datetime)) {
        if ($s.cutoff === 0 || Math.abs(distance(data.datetime)) < $s.cutoff) {
          $(this).text(inWords(data.datetime));
        }
      }
      return this;
    };
    prepareData = function(element) {
      var text;
      element = $(element);
      if (!element.data("timeago")) {
        element.data("timeago", {
          datetime: $t.datetime(element)
        });
        text = $.trim(element.text());
        if ($t.settings.localeTitle) {
          element.attr("title", element.data("timeago").datetime.toLocaleString());
        } else {
          if (text.length > 0 && !($t.isTime(element) && element.attr("title"))) {
            element.attr("title", text);
          }
        }
      }
      return element.data("timeago");
    };
    inWords = function(date) {
      return $t.inWords(distance(date));
    };
    distance = function(date) {
      return new Date().getTime() - date.getTime();
    };
    $.timeago = function(timestamp) {
      if (timestamp instanceof Date) {
        return inWords(timestamp);
      } else if (typeof timestamp === "string") {
        return inWords($.timeago.parse(timestamp));
      } else if (typeof timestamp === "number") {
        return inWords(new Date(timestamp));
      } else {
        return inWords($.timeago.datetime(timestamp));
      }
    };
    $t = $.timeago;
    $.extend($.timeago, {
      settings: {
        refreshMillis: 60000,
        allowPast: true,
        allowFuture: false,
        localeTitle: false,
        parenthesis: false,
        cutoff: 0,
        strings: {
          prefixAgo: null,
          prefixFromNow: null,
          suffixAgo: t("ago"),
          suffixFromNow: t("from now"),
          inPast: t("any moment now"),
          seconds: t("less than a minute"),
          minute: t("about a minute"),
          minutes: t("%d minutes"),
          hour: t("about an hour"),
          hours: t("about %d hours"),
          day: t("a day"),
          days: t("%d days"),
          month: t("about a month"),
          months: t("%d months"),
          year: t("about a year"),
          years: t("%d years"),
          wordSeparator: " ",
          numbers: []
        }
      },
      inWords: function(distanceMillis) {
        var $l, days, hours, minutes, output, prefix, seconds, separator, substitute, suffix, words, years;
        substitute = function(stringOrFunction, number) {
          var string, value;
          string = ($.isFunction(stringOrFunction) ? stringOrFunction(number, distanceMillis) : stringOrFunction);
          value = ($l.numbers && $l.numbers[number]) || number;
          return string.replace(/%d/i, value);
        };
        if (!this.settings.allowPast && !this.settings.allowFuture) {
          throw "timeago allowPast and allowFuture settings can not both be set to false.";
        }
        $l = this.settings.strings;
        prefix = $l.prefixAgo;
        suffix = $l.suffixAgo;
        if (this.settings.allowFuture) {
          if (distanceMillis < 0) {
            prefix = $l.prefixFromNow;
            suffix = $l.suffixFromNow;
          }
        }
        if (!this.settings.allowPast && distanceMillis >= 0) {
          return this.settings.strings.inPast;
        }
        seconds = Math.abs(distanceMillis) / 1000;
        minutes = seconds / 60;
        hours = minutes / 60;
        days = hours / 24;
        years = days / 365;
        words = seconds < 45 && substitute($l.seconds, Math.round(seconds)) || seconds < 90 && substitute($l.minute, 1) || minutes < 45 && substitute($l.minutes, Math.round(minutes)) || minutes < 90 && substitute($l.hour, 1) || hours < 24 && substitute($l.hours, Math.round(hours)) || hours < 42 && substitute($l.day, 1) || days < 30 && substitute($l.days, Math.round(days)) || days < 45 && substitute($l.month, 1) || days < 365 && substitute($l.months, Math.round(days / 30)) || years < 1.5 && substitute($l.year, 1) || substitute($l.years, Math.round(years));
        separator = $l.wordSeparator || "";
        if ($l.wordSeparator === undefined) {
          separator = " ";
        }
        output = $.trim([prefix, words, suffix].join(separator));
        if (this.settings.parenthesis) {
          return "(" + output + ")";
        } else {
          return output;
        }
      },
      parse: function(iso8601) {
        var s;
        s = $.trim(iso8601);
        s = s.replace(/\.\d+/, "");
        s = s.replace(/-/, "/").replace(/-/, "/");
        s = s.replace(/T/, " ").replace(/Z/, " UTC");
        s = s.replace(/([\+\-]\d\d)\:?(\d\d)/, " $1$2");
        s = s.replace(/([\+\-]\d\d)$/, " $100");
        return new Date(s);
      },
      datetime: function(elem) {
        var iso8601;
        iso8601 = ($t.isTime(elem) ? $(elem).attr("datetime") : $(elem).attr("title"));
        return $t.parse(iso8601);
      },
      isTime: function(elem) {
        return $(elem).get(0).tagName.toLowerCase() === "time";
      }
    });
    functions = {
      init: function() {
        var $s, refresh_el;
        refresh_el = $.proxy(refresh, this);
        refresh_el();
        $s = $t.settings;
        if ($s.refreshMillis > 0) {
          this._timeagoInterval = setInterval(refresh_el, $s.refreshMillis);
        }
      },
      update: function(time) {
        var parsedTime;
        parsedTime = $t.parse(time);
        $(this).data("timeago", {
          datetime: parsedTime
        });
        if ($t.settings.localeTitle) {
          $(this).attr("title", parsedTime.toLocaleString());
        }
        refresh.apply(this);
      },
      updateFromDOM: function() {
        $(this).data("timeago", {
          datetime: $t.parse(($t.isTime(this) ? $(this).attr("datetime") : $(this).attr("title")))
        });
        refresh.apply(this);
      },
      dispose: function() {
        if (this._timeagoInterval) {
          window.clearInterval(this._timeagoInterval);
          this._timeagoInterval = null;
        }
      }
    };
    $.fn.timeago = function(action, options) {
      var fn;
      fn = (action ? functions[action] : functions.init);
      if (!fn) {
        throw new Error("Unknown function name '" + action + "' for timeago");
      }
      this.each(function() {
        fn.call(this, options);
      });
      return this;
    };
    document.createElement("abbr");
    document.createElement("time");
  });

}).call(this);

//# sourceMappingURL=jquery-timeago.map
