<?php 
namespace Concrete\Package\CcOptinFree\Models;

class CcOptinEmailDesign extends CcOptinDesign
{
	const Table = 'cc_optin_design_email';
	public $_table = self::Table;

	public $header;
	public $text;
	public $image;
	public $firstNameLabel;
	public $lastNameLabel;
	public $phoneLabel;
	public $emailLabel;
	public $buttonText;
	public $closeLinkText;

	// Text fields for validation
	private $textFields = array(
		'header', 'firstNameLabel', 'lastNameLabel', 'phoneLabel', 
		'emailLabel', 'buttonText', 'closeLinkText'
	);

	public function validate($val) {
		$val->test('text', '*', false);
		$val->test('image', '|\d+');

		foreach ($this->textFields as $field) {
			$val->test($field, array(0, 255), false);
		}
	}

	public function isEmpty() {
		foreach ($this->textFields as $field) {
			if(!empty($this->$field)) return false;
		}
		return true;
	}
}
