<?php 
namespace Concrete\Package\CcOptinFree\Models;

abstract class CcOptinType extends CcOptinModel
{
	// Prepros fails here, cannot add it.
	public static $classMap = array(1 => "CcOptinPopup", 2 => "CcOptinSlideIn");
	public static $classNames;

	public static function __staticConstruct() {
		self::$classNames = array(1 => t("Pop-up"), 2 => t("Slide-in"));
	}

	///// Common fields /////

	public $id;
	public $campaignID;

	///// End common fields /////

	abstract public function jsonData(); // parent::toJson('id', 'data', 'properties')
	abstract public function validate($val);

	public function dependencies() { return array(); }

	public function name() { 
		$key = array_search(get_class($this), self::$classMap);
		return self::$classNames[$key];
	}
}

CcOptinType::__staticConstruct();

///// The concrete Types needs to have a js representation in display-campaign.coffee
///// The css class added in display_campaign.php will be converted to lowercase underscore,
///// so CcOptinPopup -> cc_optin_popup

class CcOptinPopup extends CcOptinType
{
	const Table = 'cc_optin_type_popup';
	public $_table = self::Table;

	public $overlayColor;
	public $animation;
	public $preventOverlayClose;

	public function dependencies() { return array('cc-plainmodal'); }

	public function jsonData() {
		return parent::toJson('id', 'overlayColor', 'animation', 'preventOverlayClose');
	}

	public function validate($val) {
		$val->test('overlayColor', '');
		$val->test('animation', '0');
		$val->test('preventOverlayClose', '0');
	}
}

