<?php  defined('C5_EXECUTE') or die(_("Access Denied."));

use Concrete\Package\CcOptinFree\CcOptin;

$th = Loader::helper("text");
$form = Loader::helper('form');
$dh = Loader::helper('concrete/dashboard');
$ih = Loader::helper('concrete/ui');

// Need to set this here, to make sure autosort is set up.
$subscribers = $list->getPage();
?>

<?php  if($list->showingAll()) { ?>
	<div class="ccm-dashboard-header-buttons">
		<button class="btn btn-danger delete-all-subscribers"><?php  echo t('Delete all subscribers') ?></button>
	</div>
<?php  } ?>

<div class="ccm-dashboard-content-full">
	<div class="ccm-search-fields">
		<?php  if(!$list->showingAll()) { ?>
			<a href="<?php  echo $this->action('') ?>"><?php  echo t('Display all subscribers') ?></a>
		<?php  } else { ?>
			<span>&nbsp;</span>
		<?php  } ?>
	</div>

	<p>&nbsp;</p>

	<form id="subscribers-form" method="POST" action="<?php  echo $this->action('action') ?>">
		<div class="ccm-search-fields">
			<?php  echo $form->select(
				'action', 
				array('' => t('** With selected'), 'delete' => t('Delete')),
				false,
				array('style' => 'width:300px')) 
			?>		
			<img src="<?php  echo CcOptin::path('img/preloader.gif') ?>" data-val-loader style="display:none;" />
		</div>

		<div class="table-responsive">
			<table id="subscribers-table" border="0" cellspacing="0" cellpadding="0" class="ccm-search-results-table">	
				<thead>
				<tr>
					<th><span class="ccm-search-results-checkbox"><input type="checkbox" class="ccm-flat-checkbox check-all" /></span></th>
					<?php  foreach($list->columns() as $col) { 
						$name = $col->getColumnName();
						$key = $col->getColumnKey();
						?>
						<?php  if ($col->isColumnSortable()) { ?>
							<th class="<?php  echo $list->getSearchResultsClass($key)?>">
								<a href="<?php  echo $list->getSortByURL($key, $col->getColumnDefaultSortDirection()) ?>"><?php  echo $name ?></a>
							</th>
						<?php  } else { ?>
							<th><?php  echo $name ?></th>
						<?php  } ?>
					<?php  } ?>
				</tr>
				</thead>
				<tbody>
				<?php  foreach($subscribers as $subscriber) { // Cannot use $list->getPage() directly, it must be called before $list->columns() ?>
					<tr>
						<td>
							<span class="ccm-search-results-checkbox">
								<input type="checkbox" name="id[]" class="ccm-flat-checkbox" value="<?php  echo $subscriber->id() ?>">
							</span>
						</td>
						<?php  foreach($list->columns() as $col) { ?>
							<td><?php  echo $col->getColumnValue($subscriber) ?></td>
						<?php  } ?>
					</tr>
				<?php  } ?>
				</tbody>
			</table>
		</div>
	</form>

	<div class="ccm-pane-dialog-pagination">
		<?php  $list->displayPagingV2() ?>
	</div>

	<p>&nbsp;</p>

	<form id="format-form" method="POST" action="<?php  echo $this->action('setFormat') ?>" class="ccm-search-fields">
		<div id="ccm-export-results-wrapper">

			<?php  echo t('Separator:') ?>
			<?php  echo $form->select('separator', $format['separators'], $format['separator'], array('style' => 'width: 120px;')) ?>

			<?php  echo t('Timestamp format') ?> (<a href="http://php.net/manual/function.date.php#refsect1-function.date-parameters" target="_blank">date</a>):
			<?php  echo $form->text('format', $format['format'], array('style' => 'width: 130px;')) ?>

			<button class="btn" type="button" data-default="<?php  echo $th->entities($format['defaultFormat']) ?>"><?php  echo t('Reset to default') ?></button>
			<a id="ccm-export-results" href="<?php  echo $this->action('export') ?>" download><span></span><?php  echo t('Export list')?></a>

			<img src="<?php  echo CcOptin::path('img/preloader.gif') ?>" data-val-loader style="display:none;" />
		</div>
	</form>
</div>
